#  Copyright (C) 2009 Registro.br. All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
# 1. Redistribution of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY REGISTRO.BR ``AS IS AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIE OF FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
# EVENT SHALL REGISTRO.BR BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
# OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
# TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
# USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
# DAMAGE.
 
from StringIO import StringIO

def usage(command):
	print "Command usage:"
	if (command == 'server'):
		print command + ' <server_IP>'
		
	elif (command == 'port'):
		print command + ' <server_port>'
		
	elif (command in ['login', 'add-user']):
		print command + ' -u <username>'
		
	elif (command in ['hello', 'logout']):
		print command
	
	elif (command == 'change-password'):
		print command + ' -u <username>'
		
	elif (command == 'new-zone'):
		print 'new-zone -z <zonename> [--ttl=<ttl> --mname=<mname> --rname=<rname> --serial=<serial> --refresh=<refresh> --retry=<retry> --expire=<expire> --minimum=<minimum> --key-size=<key_size> --rrsig-validity=<signature_validity> --no-dnssec --slave-group=<groupname>]'
	
	elif (command == 'import-zone'):
		print command + ' -z <zonename> -s <server_ip> [-p <port> ]'
					
	elif (command == 'list-zones'):
		print 'list-zones'
		
	elif (command == 'print-zone'):
		print 'print-zone -z <zonename>'

	elif (command == 'zone-exists'):
		print 'zone-exists -z <zonename>'

	elif (command == 'add-rr' or command == 'remove-rr'):
		print command + ' -z <zonename> -o <ownername> -t <type> -r "<rdata>" [--ttl=<ttl>]'
		
	elif (command == 'pub-zone'):
		print command + ' -z <zonename> [-s <serial> -i|--incremental -f|--full ]'
		
	elif (command == 'remove-zone'):
		print command + ' -z <zonename>'
		
	elif (command == 'zone-version'):
		print command + ' -z <zonename>'
		
	elif (command == 'set-expiration-period'):
		print command + ' -z <zonename> [--rrsig-validity=<signature_validity>]'
		
	elif (command == 'new-key'):
		print command + ' -z <zonename> [--key-size=<key_size> --ksk|--zsk --flags=<flags> --status=<key_status> ]'
		
	elif (command == 'import-key'):
		print command + ' -z <zonename> -k <key_file> [--ksk|--zsk --flags=<flags> --status=<key_status> ]'
		
	elif (command == 'list-keys'):
		print command + ' -z <zonename>'
		
	elif (command == 'change-key-status'):
		print command + ' -z <zonename> -k <key_name> -o|--old-status=<old_status> -n|--new-status=<new_status>'
	
	elif (command == 'remove-key'):
		print command + ' -z <zonename> -k <key_name>'
		
	elif (command in ['new-slavegroup', 'remove-slavegroup']):
		print command + ' -g <slavegroup_name>'
	
	elif (command in ['assign-slavegroup', 'unassign-slavegroup']):
		print command + ' -z <zonename> -g <slavegroup_name>' 
		
	elif (command == 'list-slavegroups'):
		print command
		
	elif (command == 'list-zones-by-slavegroup'):
		print command + ' -g <slavegroup_name>'
		
	elif (command == 'print-slavegroup'):
		print command + ' -g <slavegroup_name>'
	
	elif (command in ['add-slave', 'remove-slave']):
		print command + ' -g <slavegroup_name> -s <slave_ip> [-p <slave_port>]'
		
	elif (command == 'list-slaves'):
		print command + ' -z <zonename>'
		
	elif (command in ['new-tsig-key', 'remove-tsig-key']):
		print command + ' -s <server_ip> -k <key_name>'
	
	elif (command == 'list-tsig-keys'):
		print command + ' -s <server_ip>'

	elif (command == 'add-zone-user'):
		print command + ' -z <zonename> -u <username>'

	elif (command == 'remove-zone-user'):
		print command + ' -z <zonename> -u <username>'

	elif (command == 'shutdown'):
		print 'shutdown'


def help():
	help = StringIO()
	print >> help, "Available commands:"
	print >> help
	print >> help, "add-rr"
	print >> help, "add-slave"
	print >> help, "add-user"
	print >> help, "add-zone-user"
	print >> help, "assign-slavegroup"
	print >> help, "change-key-status"
	print >> help, "change-password"
	print >> help, "hello"
	print >> help, "import-key"
	print >> help, "import-zone"
	print >> help, "list-keys"
	print >> help, "list-slavegroups"
	print >> help, "list-slaves"
	print >> help, "list-tsig-keys"
	print >> help, "list-zones"
	print >> help, "list-zones-by-slavegroup"
	print >> help, "login"
	print >> help, "logout"
	print >> help, "new-key"
	print >> help, "new-slavegroup"
	print >> help, "new-tsig-key"
	print >> help, "new-zone"
	print >> help, "print-slavegroup"
	print >> help, "print-zone"
	print >> help, "pub-zone"
	print >> help, "remove-key"
	print >> help, "remove-rr"
	print >> help, "remove-slave"
	print >> help, "remove-slavegroup"
	print >> help, "remove-tsig-key"
	print >> help, "remove-zone"
	print >> help, "remove-zone-user"
	print >> help, "set-expiration-period"
	print >> help, "shutdown"
	print >> help, "unassign-slavegroup"
	print >> help, "zone-version"
	print >> help, "zone-exists"
	return help.getvalue()
